<?php
/**
 * Created by PhpStorm.
 * User: wanderleijunior
 * Date: 12/07/19
 * Time: 10:17
 */

namespace Controller;

use Util\InstanceProvider;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Util\Utilities;

class Produto
{
    public function findCollectionVariableMeasures(DTO\Request\Filter $request, DTO\Response $response) {
        $serviceProduto = InstanceProvider::getService()->getProduto();
        try {
            $conditions     = $request->getFilterCriteria()->getConditions();
            $dataSourceName = $request->getFilterCriteria()->getDataSourceName();
            $page           = $request->getFilterCriteria()->getPage();
            $pageSize       = $request->getFilterCriteria()->getPageSize();
            $orderBy        = $request->getFilterCriteria()->getOrderBy();
            $nrProdutoId    = Utilities::getValueInFilterDataSourceByName($conditions, 'NRPRODUTO_ID', true);
            $nrOrgId        = Utilities::getValueInFilterDataSourceByName($conditions, 'NRORG_ID', true);
            $cdServOrca     = Utilities::getValueInFilterDataSourceByName($conditions, 'CDSERVORCA', true);
            $registers      = $serviceProduto->findCollectionVariableMeasures($conditions, $dataSourceName,
                $page, $pageSize, $orderBy, $nrProdutoId, $nrOrgId, $cdServOrca);
            $response->addDataSet(new DataSource\DataSet('collectionVariableMeasurement', $registers));
        } catch(\Exception $ex){
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }

    public function findProdutosContratados(DTO\Request\Filter $request, DTO\Response $response) {
        $serviceProduto = InstanceProvider::getService()->getProduto();
        try {
            $conditions  = $request->getFilterCriteria()->getConditions();
            $nrparcnegocio  = Utilities::getValueInFilterDataSourceByName($conditions, 'NRPARCNEGOCIO', true);
            $data = $serviceProduto->findProdutosContratados($conditions, $nrparcnegocio);
            $response->addDataSet(new DataSource\DataSet('produtosContratados', $data));
        } catch(\Exception $ex){
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }

    public function findproductsTranslations(DTO\Request\Filter $request, DTO\Response $response) {
        $serviceProduto = InstanceProvider::getService()->getProduto();
        try {
            $conditions  = $request->getFilterCriteria()->getConditions();
            $nrparcnegocio  = Utilities::getValueInFilterDataSourceByName($conditions, 'LANGUAGE', true);
            $data = $serviceProduto->findproductsTranslations($nrparcnegocio);
            $response->addDataSet(new DataSource\DataSet('productsTranslations', $data));
        } catch(\Exception $ex){
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
}
